/*
  Copyright (C) 2021 Arm Limited or its affiliates. All rights reserved.

  SPDX-License-Identifier: Apache-2.0

  Licensed under the Apache License, Version 2.0 (the License); you may
  not use this file except in compliance with the License.
  You may obtain a copy of the License at

  www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an AS IS BASIS, WITHOUT
  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

#include "src/transforms/scheduler/tensor_anchors.h"
#include "src/transforms/scheduler/search_engine.h"

namespace mlir {
namespace planner {

// std::unordered_map<value_unique_id, TensorAnchor>;
void print_tensor_anchors(TensorAnchors tensoranchors) {
  std::cout << std::endl;
  std::cout << "Tensor Anchors: " << std::endl;
  for (auto ts : tensoranchors) {
    std::cout << "Id: " << ts.first << " No of Consumers Partial Plans: "
              << ts.second.get_consumers().size()
              << " No of Producers Partial Plans: "
              << ts.second.get_producers().size() << std::endl;
    std::cout << "    Producers: " << std::endl;
    for (auto producer : ts.second.get_producers())
      std::cout << "        " << producer << std::endl;
    std::cout << "    Consumers: " << std::endl;
    for (auto consumer : ts.second.get_consumers())
      std::cout << "        " << consumer << std::endl;
  }
  std::cout << std::endl;
}

void SearchEngine::generate_tensor_anchors(partition &p) {
  /*
     Iterate over the partition. If the Tensor is not outside the partial plan
     then we add it as a TensorAnchors
  */
  for (auto op : p) {
    /*
       Check if Input is generated from an Op inside the partition
       Inputs are really outputs so we don't need to check both
    */
    if (p.size() > 1)
      ASSERT_COND(op->getNumOperands() != 1,
                  "generate_tensor_anchors::Op has more than 1 Operand");
    ASSERT_COND(op->getNumResults() != 1,
                "generate_tensor_anchors::Op has more than 1 Result");
    for (mlir::Value v : op->getOperands()) {
      Operation *defining_op = v.getDefiningOp();
      if (std::find(p.begin(), p.end(), defining_op) != p.end()) {
        auto ta = TensorAnchor(v);

        /* SSA: A Value can only be generated by a single Op */
        std::list<BitVector> producers = {
            partition_bitvectorlookup[defining_op]};
        ta.set_producers(producers);

        std::list<BitVector> consumers;
        for (Operation *consumer : v.getUsers())
          consumers.push_back(partition_bitvectorlookup[consumer]);
        ta.set_consumers(consumers);

        partition_tensoranchors.emplace(ta.get_id(), ta);
      }
      // else
      //    Value Defined from Op Outside partition so we it must be a full
      //    tensor and hence we dont need a TensorAnchor
    }
  }
}

} // namespace planner
} // namespace mlir
